package org.drools.cep;

import org.drools.modelcompiler.dsl.pattern.D;
import org.drools.model.Index.ConstraintType;
import org.kie.hacep.sample.kjar.StockTickEvent;
import java.util.UUID;
import org.kie.remote.DroolsExecutor;
import org.kie.hacep.sample.kjar.Result;
import static org.drools.cep.Rules9CBA18B4798E6830BBAFF1CD619105DF.*;

public class Rules9CBA18B4798E6830BBAFF1CD619105DFRuleMethods0 {

    /**
     * Rule name: StockAverage
     */
    public static org.drools.model.Rule rule_StockAverage() {
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.Result> var_$r = D.declarationOf(org.kie.hacep.sample.kjar.Result.class,
                                                                                                   DomainClassesMetadata9CBA18B4798E6830BBAFF1CD619105DF.org_kie_hacep_sample_kjar_Result_Metadata_INSTANCE,
                                                                                                   "$r");
        final org.drools.model.Variable<java.lang.String> var_$name = D.declarationOf(java.lang.String.class,
                                                                                      DomainClassesMetadata9CBA18B4798E6830BBAFF1CD619105DF.java_lang_String_Metadata_INSTANCE,
                                                                                      "$name");
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.StockTickEvent> var_GENERATED_$pattern_StockTickEvent$1$ = D.declarationOf(org.kie.hacep.sample.kjar.StockTickEvent.class,
                                                                                                                                             DomainClassesMetadata9CBA18B4798E6830BBAFF1CD619105DF.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE,
                                                                                                                                             "GENERATED_$pattern_StockTickEvent$1$");
        final org.drools.model.Variable<Double> var_$p = D.declarationOf(Double.class,
                                                                         "$p");
        final org.drools.model.Variable<java.lang.Double> var_$avg = D.declarationOf(java.lang.Double.class,
                                                                                     DomainClassesMetadata9CBA18B4798E6830BBAFF1CD619105DF.java_lang_Double_Metadata_INSTANCE,
                                                                                     "$avg");
        org.drools.model.Rule rule = D.rule("org.drools.cep",
                                            "StockAverage").build(D.pattern(var_$r).bind(var_$name,
                                                                                         org.drools.cep.P90.LambdaExtractor90D624CEE73982E2AA78294A98D0E884.INSTANCE,
                                                                                         D.reactOn("stockName")),
                                                                  D.accumulate(D.pattern(var_GENERATED_$pattern_StockTickEvent$1$).expr("E44016C0D11BC5C44AC48D88E9FD4D6A",
                                                                                                                                        var_$name,
                                                                                                                                        org.drools.cep.P2D.LambdaPredicate2D30CFB30777F493945D180A8FCD2E27.INSTANCE,
                                                                                                                                        D.betaIndexedBy(java.lang.String.class,
                                                                                                                                                        org.drools.model.Index.ConstraintType.EQUAL,
                                                                                                                                                        DomainClassesMetadata9CBA18B4798E6830BBAFF1CD619105DF.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE.getPropertyIndex("company"),
                                                                                                                                                        org.drools.cep.P91.LambdaExtractor918359ADCF40B34E587FD529D030780D.INSTANCE,
                                                                                                                                                        org.drools.cep.P8E.LambdaExtractor8E3ED2E1FE9371EF266FB6B0E324617A.INSTANCE),
                                                                                                                                        D.reactOn("company")).bind(var_$p,
                                                                                                                                                                   org.drools.cep.P09.LambdaExtractor09F2A7408B413D2DF4842DB56AB69EDF.INSTANCE,
                                                                                                                                                                   D.reactOn("price")),
                                                                               D.accFunction(org.drools.core.base.accumulators.AverageAccumulateFunction::new,
                                                                                             var_$p).as(var_$avg)),
                                                                  D.on(var_$name,
                                                                       var_$r,
                                                                       var_$avg).execute(org.drools.cep.P6B.LambdaConsequence6B47D5FABA828639D489097B4A8D01A2.INSTANCE));
        return rule;
    }

    /**
     * Rule name: StockLog
     */
    public static org.drools.model.Rule rule_StockLog() {
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.StockTickEvent> var_$stock = D.declarationOf(org.kie.hacep.sample.kjar.StockTickEvent.class,
                                                                                                               DomainClassesMetadata9CBA18B4798E6830BBAFF1CD619105DF.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE,
                                                                                                               "$stock");
        org.drools.model.Rule rule = D.rule("org.drools.cep",
                                            "StockLog").build(D.pattern(var_$stock),
                                                              D.on(var_$stock).execute(org.drools.cep.PFF.LambdaConsequenceFF88EC0C6B6EC27F3FACA82E21295161.INSTANCE));
        return rule;
    }
}
